#ifndef UIDOCUMENT_H
#define UIDOCUMENT_H

//#include "UINetwork.h"
#include <vector>
#include <string>
#include <tree.h>
#include <map>
#include "UINetwork.h"

//class UINetwork;
class UINodeMenu;
class Network;
class ParameterSet;

class SubnetInfo {
  public:
   vector<string> inputs;
   vector<string> outputs;
   vector<string> params;
  public:
};

class DocParameterDataText {
public:
   string name;
   string value;
   string type;
};

class UIDocument {//: public GnomeMDIChild{
   
protected:
   //GnomeMDIChild child; //this must be first!!!

   //GtkWidget *view;
   vector<UINetwork *> networks;
   bool modified;
   
   static map<string, SubnetInfo *> externalDocInfo;

   map<string, SubnetInfo *> preloadInfo;
   vector<DocParameterDataText> textParams;

   string docName;
   string path;
   bool untitled;

public:
   UIDocument(string _name);

   virtual ~UIDocument();

   virtual void load();
   
   void setModified() {modified=true;}
   
   void resetModified() {modified=false;}
   
   bool isModified() {return modified;}
   
   UINetwork *addNetwork(string name, UINetwork::Type type);
   
   UINetwork *addNetwork(xmlNodePtr xmlNet);
   
   
   bool isUntitled() {return untitled;}
   
   virtual const string &getName() {return docName;}
   
   const string &getPath() {return path;}
   
   void save();
   
   void export2net();
   
   void addParameterText(string name, string value, string type);
   
   UINetwork *getNetworkNamed(const string &n);
   
   vector<string> getNetInputs(const string &netName);
   
   vector<string> getNetOutputs(const string &netName);
   
   vector<string> getNetParams(const string &netName);
   
   static void loadNetInfo(xmlNodePtr net, map<string, SubnetInfo *> &infoMap, string netName = "");

   void loadAllSubnetInfo(xmlNodePtr net);

   static void scanDL();

   static void loadExtDocInfo();
   
   virtual UINetwork *newNetwork(UIDocument *_doc, const string &_name, UINetwork::Type type);
   
   virtual UINetwork *newNetwork(UIDocument *_doc, xmlNodePtr _net);
   
   Network *build(const string &_name, const ParameterSet &params);

   static Network *buildExternal(const string &type, const string &_name, const ParameterSet &params);

   virtual void run();

   virtual void run(ParameterSet &p);

   virtual void setFullPath(const string &fullpath);
};




#endif
